// File author is Ítalo Lima Marconato Matias
//
// Created on December 18 of 2017, at 12:35 BRST
// Last edited on December 21 of 2017, at 21:11 BRST
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef __PORT_H__
#define __PORT_H__

#include <chicago/types.h>

static inline Void PortOutByte(UInt16 port, UInt8 data)
{
	Asm Volatile("outb %1, %0" :: "dN"(port), "a"(data));
}

static inline UInt8 PortInByte(UInt16 port)
{
	UInt8 ret;
	Asm Volatile("inb %1, %0" : "=a"(ret) : "dN"(port));
	return ret;
}

static inline Void PortOutWord(UInt16 port, UInt16 data)
{
	Asm Volatile("outw %1, %0" :: "dN"(port), "a"(data));
}

static inline UInt16 PortInWord(UInt16 port)
{
	UInt16 ret;
	Asm Volatile("inw %1, %0" : "=a"(ret) : "dN"(port));
	return ret;
}

static inline Void PortOutLong(UInt16 port, UInt32 data)
{
	Asm Volatile("outl %1, %0" :: "dN"(port), "a"(data));
}

static inline UInt32 PortInLong(UInt16 port)
{
	UInt32 ret;
	Asm Volatile("inl %1, %0" : "=a"(ret) : "dN"(port));
	return ret;
}

static inline Void PortOutMultiple(UInt16 port, PUInt8 data, ULong size)
{
	Asm Volatile("rep outsw" : "+S"(data), "+c"(size) : "d"(port));
}

static inline Void PortInMultiple(UInt16 port, PUInt8 data, ULong size)
{
	Asm Volatile("rep insw" : "+D"(data), "+c"(size) : "d"(port) : "memory");
}

#endif		// __PORT_H__
