// File author is Ítalo Lima Marconato Matias
//
// Created on December 18 of 2017, at 12:31 BRST
// Last edited on December 18 of 2017, at 12:31 BRST
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef __CONSOLE_H__
#define __CONSOLE_H__

#include <chicago/types.h>

/* Console possible colors */

#define CONSOLE_COLOR_BLACK 0
#define CONSOLE_COLOR_BLUE 1
#define CONSOLE_COLOR_GREEN 2
#define CONSOLE_COLOR_CYAN 3
#define CONSOLE_COLOR_RED 4
#define CONSOLE_COLOR_MAGENTA 5
#define CONSOLE_COLOR_BROWN 6
#define CONSOLE_COLOR_LIGHT_GRAY 7
#define CONSOLE_COLOR_DARK_GRAY 8
#define CONSOLE_COLOR_LIGHT_BLUE 9
#define CONSOLE_COLOR_LIGHT_GREEN 10
#define CONSOLE_COLOR_LIGHT_CYAN 11
#define CONSOLE_COLOR_LIGHT_RED 12
#define CONSOLE_COLOR_LIGHT_MAGENTA 13
#define CONSOLE_COLOR_YELLOW 14
#define CONSOLE_COLOR_WHITE 15

/* Message possible levels */

#define MESSAGE_LEVEL_INFO 0x00
#define MESSAGE_LEVEL_WARNING 0x01
#define MESSAGE_LEVEL_ERROR 0x02

UInt8 ConsoleGetBackground(Void);
UInt8 ConsoleGetForeground(Void);
Void ConsoleSetBackground(UInt8 color);
Void ConsoleSetForeground(UInt8 color);
Void ConsoleSetColor(UInt8 back, UInt8 fore);
Void ConsoleClear(Void);
Void ConsoleWriteCharacter(Char data);
Void ConsoleWriteString(PChar data);
Void ConsoleWriteInteger(ULong data, UInt8 base);
Void ConsoleWriteFormated(PChar data, ...);
Void Message(Int level, PChar data, ...);
Void Panic(PChar data, ...);

#endif		// __CONSOLE_H__
