// File author is Ítalo Lima Marconato Matias
//
// Created on December 18 of 2017, at 22:26 BRST
// Last edited on December 28 of 2017, at 19:57 BRST
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef __TASK_H__
#define __TASK_H__

#include <chicago/list.h>

typedef struct
{
	UInt32 pid;
	PList file_list;
	UInt32 file_count;
	UIntPtr heap_start;
	UIntPtr heap_current;
	UIntPtr heap_current_aligned;
	UInt32 last_error;
	PVoid libc_exit_handlers;
	UIntPtr libc_exit_handler_ptr;
	PVoid libc_file_list;
} ProcessInfo, *PProcessInfo;

typedef struct ProcessStruct
{
	UInt32 id;
	UInt32 esp;
	UInt32 stack;
	UInt32 eip;
	UInt32 cr3;
	UInt32 state;
	Boolean executed;
	PVoid private_data;
	struct ProcessStruct* next;
	struct ProcessStruct* prev;
} Process, *PProcess;

PProcess ProcessCreate(UInt32 entry);
Void ProcessAdd(PProcess proc);
Void ProcessExit(Void);
PProcess ProcessGet(UInt32 pid);
Void ProcessForceSwitch(Void);
Void TaskInit(Void);

#endif
