// File author is Ítalo Lima Marconato Matias
//
// Created on December 18 of 2017, at 20:17 BRST
// Last edited on December 18 of 2017, at 21:44 BRST
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#include <chicago/arch/port.h>
#include <chicago/arch/idt.h>

UInt32 TimerTicks = 0;

Void TimerSleep(UInt32 ticks)
{
	UInt32 eticks = TimerTicks + ticks;
	while (TimerTicks < eticks) ;
}

Void TimerInit(UInt32 freq)
{
	PortOutByte(0x43, 0x36);		// Setup timer frequency
	PortOutByte(0x40, (1193180 / freq) & 0xFF);
	PortOutByte(0x40, (1193180 / freq) >> 8);
}
