// File author is Ítalo Lima Marconato Matias
//
// Created on December 18 of 2017, at 16:58 BRST
// Last edited on December 18 of 2017, at 20:05 BRST
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef __ALLOC_H__
#define __ALLOC_H__

#include <chicago/types.h>

typedef struct MemoryAllocBlockStruct
{
	UInt32 size;
	Boolean free;
	PVoid ptr;
	struct MemoryAllocBlockStruct* next;
	struct MemoryAllocBlockStruct* prev;
	char data[1];
} MemoryAllocBlock, *PMemoryAllocBlock;

UIntPtr MemoryAlloc(UIntPtr size);
UIntPtr MemoryAlignedAlloc(UIntPtr size, UIntPtr align);
Void MemoryFree(UIntPtr block);
Void MemoryAlignedFree(UIntPtr block);
UIntPtr MemoryCalloc(UIntPtr mul, UIntPtr size);
UIntPtr MemoryAlignedCalloc(UIntPtr mul, UIntPtr size, UIntPtr align);
UIntPtr MemoryRealloc(UIntPtr block, UIntPtr size);
UIntPtr MemoryAlignedRealloc(UIntPtr block, UIntPtr size, UIntPtr align);

#endif
