// File author is Ítalo Lima Marconato Matias
//
// Created on December 18 of 2017, at 12:39 BRST
// Last edited on December 19 of 2017, at 21:55 BRST
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#ifndef __MULTIBOOT_H__
#define __MULTIBOOT_H__

#include <chicago/types.h>

typedef struct MultibootHeaderStruct
{
	UInt32 flags;
	UInt32 mem_lower;
	UInt32 mem_upper;
	UInt32 boot_device;
	UInt32 cmd_line;
	UInt32 mods_count;
	UInt32 mods_address;
	UInt32 num;
	UInt32 size;
	UInt32 address;
	UInt32 shndx;
	UInt32 mmap_length;
	UInt32 mmap_address;
	UInt32 drives_length;
	UInt32 drives_address;
	UInt32 config_table;
	UInt32 boot_loader_name;
	UInt32 apm_table;
	UInt32 vbe_control_info;
	UInt32 vbe_mode_info;
	UInt32 vbe_mode;
	UInt32 vbe_interface_segment;
	UInt32 vbe_interface_offset;
	UInt32 vbe_interface_length;
} Packed MultibootHeader, *PMultibootHeader;

typedef struct MultibootModuleStruct
{
	UInt32 mod_start;
	UInt32 mod_end;
	UInt32 cmd_line;
	UInt32 reserved;
} Packed MultibootModule, *PMultibootModule;

typedef struct
{
	UInt32 mbmagic;
	PMultibootHeader mbheader;
} BootData, *PBootData;


#endif
