// File author is Ítalo Lima Marconato Matias
//
// Created on December 18 of 2017, at 20:05 BRST
// Last edited on December 18 of 2017, at 20:05 BRST
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

#include <chicago/alloc.h>
#include <chicago/list.h>

PList ListNew(Void)
{
	PList out = (PList)MemoryAlloc(sizeof(List));
	
	out -> head = Null;
	out -> tail = Null;
	out -> length = 0;
	
	return out;
}

Void ListFree(PList list)
{
	while (list -> length)		// Free all the nodes
		MemoryFree((UIntPtr)(ListRemove(list, list -> length - 1)));
	MemoryFree((UIntPtr)list);		// And the list struct
}

Void ListAdd(PList list, PVoid data)
{
	PListNode node = (PListNode)MemoryAlloc(sizeof(ListNode));
	
	node -> data = data;
	node -> next = Null;
	
	if (!list -> tail)
	{
		list -> head = node;
		node -> prev = Null;
	}
	else
	{
		list -> tail -> next = node;
		node -> prev = list -> tail;
	}
	
	list -> tail = node;
	list -> length++;
}

PVoid ListRemove(PList list, UInt32 idx)
{
	if (idx > list -> length)
		return Null;
	
	PListNode node = list -> head;
	PVoid data = Null;
	UInt32 i = 0;
	
	while (i < idx)
	{
		node = node -> next;
		i++;
	}
	
	data = node -> data;
	
	if (node == list -> head)
		list -> head = node -> next;
	if (node == list -> tail)
		list -> tail = node -> prev;
	if (node -> prev)
		node -> prev -> next = node -> next;
	if (node -> next)
		node -> next -> prev = node -> prev;
		
	node -> prev = Null;
	node -> next = Null;
	
	MemoryFree((UIntPtr)node);
	
	list -> length--;
	
	return data;
}

PListNode ListGet(PList list, UInt32 idx)
{
	if (idx > list -> length)
		return Null;
	
	PListNode node = list -> head;
	UInt32 i = 0;
	
	while (i < idx)
	{
		node = node -> next;
		i++;
	}
	
	return node;
}
